//************************************ Compile Settings ************************************//

// Admin flag settings for giving points/badges and server saved data reset
// These can also be set in cmdaccess.ini without need to change here
// (See amxconst.inc for more admin level constants)
#define ADMIN_LEVEL ADMIN_IMMUNITY
#define ADMIN_RESET ADMIN_IMMUNITY

// Note: Changing any of the above the above requires plugin to be recompiled
//******************************************************************************************//
#include <amxmodx>
#include <amxmisc>
#include <fakemeta>
#include <hamsandwich>
#include <csx>
//#include <colorstatus>

new const gPluginName[] = "JarHead Desert Rank Mod";
new const gPluginVersion[] = "1.0";

//Message sending variables
new gmsgStatusText;

new gHudSyncAimInfo;
new gMaxPlayers;
new bool:gCZBotRegisterHam;

#define MAX_RANKS 17

//Motd variables
new configsdir[200];

//Cvar vars
new gPcvarJHDActive;
new gPcvarXpMinPlayers;
new gPcvarHudOptions;
new gPcvarFFA;
new gPcvarSaveType;
new gPcvarRankBots;
new gPcvarBotQuota;
new gPcvarSVLan;

//Cvar vars new
new gPcvarWymus;

//Current players info
new g_PlayerRank[33];
new knifekills[33];
new pistolkills[33];
new sniperkills[33];
new parakills[33];
new defuses[33];
new plants[33];
new explosions[33];
new accuracy[33];
new totalkills[33];
new gSaveKey[33][32];
new smgkills[33];
new shotgunkills[33];
new riflekills[33];
new grenadekills[33];

new bronze[33];
new silver[33];
new gold[33];

//Temp storage variables
new bool:newplayer[33];
new bool:g_imobile[33];
new highestrank;
new highestrankid;
new gStatsLoaded[33];

new g_friend[33];
new menuselection[33];
new menuItemSelection[33];
new iloscdodawanychfragow[33];

//Server stats
new highestrankserver, highestrankservername[32], mostkills, mostkillsid, mostkillsname[32], mostwins, mostwinsname[32];

//Sound Vars
new gSoundRank[] = "jhdrank/promotion.wav"; //Rank gained sound

//Sprite vars
new gSprite[22];

//nVault
#include <nvault>
new g_Vault;
new gPlayerName;

//Jhd includes
#include <colorchat>
#include "jhd/stocks.inl"
#include "jhd/const.inl"
#include "jhd/cmds.inl"
#include "jhd/events.inl"
#include "jhd/save.inl"
#include "jhd/forwards.inl"
#include "jhd/check.inl"
#include "jhd/menu.inl"
#include "jhd/hud.inl"
#include "jhd/csx.inl"
#include "jhd/ham.inl"

public plugin_init()
{
	register_plugin(gPluginName, gPluginVersion, "pRED*");	// Bazuje na Battlefield 2: Rank Mod 1.5.3 by pRED*
								// Plugin spolszczony przez MisieQ i zmodyfikowany
	//Register all the say commands

	//Public
	register_clcmd("say", "cmd_say", 0, "<target> ");
	register_clcmd("say_team", "cmd_say", 0, "<target> ");

	register_clcmd("say /mestats", "show_stats", 0, "Pokazuje twoje aktualne statystyki");
	register_clcmd("say_team /mestats", "show_stats", 0, "Pokazuje twoje aktualne statystyki");

	register_clcmd("say /serverstats", "show_server_stats", 0, "Pokazuje aktualne statystyki serwera");
	register_clcmd("say_team /serverstats", "show_server_stats", 0, "Pokazuje aktualne statystyki serwera");

	//register_clcmd("say /rankhelp", "show_rankhelp", 0, "Pokazuje informacje o odznakach");
	//register_clcmd("say_team /rankhelp", "show_rankhelp", 0, "Pokazuje informacje o odznakach");
	
	register_clcmd("say /adminmenu", "adminmenu", ADMIN_LEVEL|ADMIN_RESET, "Dostep do menu Admina");
	register_clcmd("say_team /adminmenu", "adminmenu", ADMIN_LEVEL|ADMIN_RESET, "Dostep do menu Admina");
	
	register_clcmd("add_kills", "add_kills", ADMIN_LEVEL, "Dodaje fragi graczom");
	register_clcmd("dodaj_fragi", "dodaj_fragi", ADMIN_LEVEL, "Dodaje wybrana liczbe fragow");
	register_clcmd("zabierz_fragi", "zabierz_fragi", ADMIN_LEVEL, "Zabiera wybrana liczbe fragow");
	register_clcmd("dodaj_zlote_medale", "dodaj_zlote_medale", ADMIN_LEVEL, "Dodaje wybrana liczbe zlotych medali");
	register_clcmd("zabierz_zlote_medale", "zabierz_zlote_medale", ADMIN_LEVEL, "Zabiera wybrana liczbe zlotych medali");

	//Cvars

	//FCVAR_SERVER cvar for game monitor.
	register_cvar("jhd_version", gPluginVersion, FCVAR_SERVER);

	// Set cvar to update version in case new version loaded while server still running
	set_cvar_string("jhd_version", gPluginVersion);

	gPcvarJHDActive = register_cvar("jhd_active", "1");
	gPcvarHudOptions = register_cvar("jhd_hud_options", "abcde");
	gPcvarFFA = register_cvar("jhd_ffa", "0");
	gPcvarXpMinPlayers = register_cvar("jhd_min", "2");
	gPcvarWymus = register_cvar("jhd_wymus", "0");

	gPcvarSaveType = get_cvar_pointer("csstats_rank");
	gPcvarRankBots = get_cvar_pointer("csstats_rankbots");
	gPcvarBotQuota = get_cvar_pointer("bot_quota");
	gPcvarSVLan = get_cvar_pointer("sv_lan");

	//Message sending.
	gmsgStatusText = get_user_msgid("StatusText");
	//initColorStatus();

	//Register events, logs and forwards to be captured
	register_message(SVC_INTERMISSION, "Message_Intermission");
	register_message(get_user_msgid("StatusValue"), "Message_StatusValue");

	register_event("StatusValue", "setTeam", "be", "1=1");
	register_event("StatusValue", "on_ShowStatus", "be", "1=2", "2!0");
	register_event("StatusValue", "on_HideStatus", "be", "1=1", "2=0");

	// Must use post or else is_user_alive will return false when dead player respawns
	RegisterHam(Ham_Spawn, "player", "Ham_Spawn_Post", 1);	// cz bots won't hook here must RegisterHamFromEntity

	gHudSyncAimInfo = CreateHudSyncObj();
	gMaxPlayers = get_maxplayers();
	gPlayerName = get_xvar_id("PlayerName");
}
