//Bf2 Rank Mod check File
//Contains all the badge/rank etc checking functions.

#if defined jhd_check_included
#endinput
#endif
#define jhd_check_included

public check_level(id)
{
	if ( gStatsLoaded[id] < 2 ) return;
	
	new stats[8], bodyhits[8], prevrank;
	new ranked = get_user_stats(id, stats, bodyhits);
	
	prevrank = g_PlayerRank[id];
	new newrank, counter;
	
	for (counter = 0; counter < MAX_RANKS; counter++)
	{
		if ( totalkills[id] >= floatround(gRankXP[counter]*0.1) )
		{
			newrank = counter;
		}
		else break;
	}
	
	g_PlayerRank[id] = newrank;
	
	if ( g_PlayerRank[id]==17 && gold[id] < gRankGold[0] )
		g_PlayerRank[id] = 7; //Degrade if the requirements became higher
	if ( g_PlayerRank[id]==18 && gold[id] < gRankGold[1] )
		g_PlayerRank[id] = 8; //Degrade if the requirements became higher
	if ( g_PlayerRank[id]==19 && gold[id] < gRankGold[2] )
		g_PlayerRank[id] = 15; //Degrade if the requirements became higher
	if ( g_PlayerRank[id]==20 && gold[id] < gRankGold[3] )
		g_PlayerRank[id] = 16; //Degrade if the requirements became higher
	if ( g_PlayerRank[id]==21 && gold[id] < gRankGold[4] )
		g_PlayerRank[id] = 16; //Degrade if the requirements became higher
	
	switch(newrank)
	{
		case 7:
			if ( gold[id] >= gRankGold[0] )
				g_PlayerRank[id] = 17;
		case 8:
			if ( gold[id] >= gRankGold[1] )
				g_PlayerRank[id] = 18;
		case 15:
			if ( gold[id] >= gRankGold[2] )
				g_PlayerRank[id] = 19;
		case 16:
			if ( ranked == 2 && gold[id] >= gRankGold[3] )
				g_PlayerRank[id] = 20; //Promote to General if Number 2 ranked.
			else if ( ranked == 1 && gold[id] >= gRankGold[4] )
				g_PlayerRank[id] = 21; //Promote to Marszalek Polski if Number 1 ranked.
	}
	
	if ( newplayer[id] )
	{
		ColorChat(id,TEAM_COLOR,"[BF2]^x03 Twoja ranga:^x04 %s^x03 zostala zaladowana",gRankName[g_PlayerRank[id]]);
		client_cmd(id, "spk %s", gSoundRank);
		ranking_officer_check(id);
		newplayer[id] = false;
	}
	else if ( is_ranked_higher(g_PlayerRank[id], prevrank) )
	{
		ColorChat(id,TEAM_COLOR,"[BF2]^x03 Awanasowales do rangi^x04 %s", gRankName[g_PlayerRank[id]]);
		client_cmd(id, "spk %s", gSoundRank);
		ranking_officer_check(id);
	}
	else if ( g_PlayerRank[id] != prevrank && !is_ranked_higher(g_PlayerRank[id], prevrank) )
	{
		ColorChat(id,TEAM_COLOR,"[BF2]^x03 Zostales zdegradowany do rangi^x04 %s", gRankName[g_PlayerRank[id]]);
	}
	
	if ( is_ranked_higher(g_PlayerRank[id], highestrankserver) )
	{
		highestrankserver = g_PlayerRank[id];
		new line[100], name[32];
		get_user_name(id, name, charsmax(name));
		line[0] = 0x04;
		ColorChat(id,TEAM_COLOR,"%s^x03 ma najwyzsza range na serwerze. Jego ranga to^x04 %s", name, gRankName[highestrankserver]);
	}
}

bool:is_ranked_higher(rank1, rank2)
{
	return (gRankOrder[rank1] > gRankOrder[rank2]) ? true : false;
}

public ranking_officer_check(id)
{
	new idRank = g_PlayerRank[id];
	
	if ( !is_ranked_higher(idRank, highestrank) ) return;
	
	highestrank = idRank;
	highestrankid = id;
	new name[32];
	get_user_name(id, name, charsmax(name));
	new line[100];
	line[0] = 0x04;
	ColorChat(0,TEAM_COLOR,"%s^x03 obecnie jest Liderem rankingu oficerskiego z ranga^x04 %s", name, gRankName[idRank]);
}

public ranking_officer_disconnect()
{
	new players[32], num, player;
	get_players(players, num, "h");

	highestrank = 0;
	highestrankid = 0;

	for (new i = 0; i < num; i++)
	{
		player = players[i];
		if ( is_ranked_higher(g_PlayerRank[player], highestrank) )
		{
			highestrank = g_PlayerRank[player];
			highestrankid = player;
		}
	}

	if ( !highestrank )
		return;
	
	new name[32];
	get_user_name(highestrankid, name, charsmax(name));
	new line[100];
	line[0] = 0x04;
	for (new i = 0; i < num; i++)
		ColorChat(0,TEAM_COLOR,"%s^x03 obecnie jest Liderem rankingu oficerskiego z ranga^x04 %s", name, gRankName[highestrank]);
}

public award_check()
{
	new players[32], num;
	get_players(players, num, "h");
	
	new tempfrags, id;
	
	new swapfrags, swapid;
	
	new starfrags[3]; //0 - Bronze / 1 - Silver / 2 - Gold
	new starid[3];
	
	for (new i = 0; i < num; i++)
	{
		id = players[i];
		tempfrags = get_user_frags(id);
		if ( tempfrags > starfrags[0] )
		{
			starfrags[0] = tempfrags;
			starid[0] = id;
			if ( tempfrags > starfrags[1] )
			{
				swapfrags = starfrags[1];
				swapid = starid[1];
				starfrags[1] = tempfrags;
				starid[1] = id;
				starfrags[0] = swapfrags;
				starid[0] = swapid;
				
				if ( tempfrags > starfrags[2] )
				{
					swapfrags = starfrags[2];
					swapid = starid[2];
					starfrags[2] = tempfrags;
					starid[2] = id;
					starfrags[1] = swapfrags;
					starid[1] = swapid;
				}
			}
		}
		//save_badges(id);
	}
	
	new winner = starid[2];
	new bool:newleader = false;
	
	if ( !winner )
		return;
	
	//We now should have our three awards
	
	bronze[starid[0]]++;
	silver[starid[1]]++;
	gold[winner]++;
	
	new name[32];
	get_user_name(starid[2], name, charsmax(name));
	
	if ( gold[winner] > mostwins )
	{
		mostwins = gold[winner];
		newleader = true;
		formatex(mostwinsname, charsmax(mostwinsname), name);
	}
	
	//server_save();
	
	new line[100];
	line[0] = 0x04;
	ColorChat(0,TEAM_COLOR,"[JHD]^x03 Gratulacje dla Zwyciezcow!");
	
	line[0] = 0x04;
	
	get_user_name(starid[0], name, charsmax(name));
	line[0] = 0x04;
	ColorChat(0,TEAM_COLOR,"[JHD] %s^x03 - Brazowy Medal -^x04 %i^x03 Zabojstw", name, starfrags[0]);
	
	get_user_name(starid[1], name, charsmax(name));
	line[0] = 0x04;
	ColorChat(0,TEAM_COLOR,"[JHD] %s^x03 - Srebrny Medal -^x04 %i^x03 Zabojstw", name, starfrags[1]);
	
	get_user_name(starid[2], name, charsmax(name));
	
	if (newleader)
		formatex(line[1], 98, "%s - Zloty Medal - %i Zabojstw - Wygrywa", name, starfrags[2]);
	else
		formatex(line[1], 98, "%s - Zloty Medal - %i Zabojstw", name, starfrags[2]);
	
	ShowColorMessage(starid[2], MSG_BROADCAST, line);
}
/* AMXX-Studio Notes - DO NOT MODIFY BELOW HERE
*{\\ rtf1\\ ansi\\ deff0{\\ fonttbl{\\ f0\\ fnil Tahoma;}}\n\\ viewkind4\\ uc1\\ pard\\ lang1045\\ f0\\ fs16 \n\\ par }
*/
